## caffe-contrib 1.0.0

=== CMakeLists.txt ===
# Building docs script
# Requirements:
#   sudo apt-get install doxygen texlive ruby-dev
#   sudo gem install jekyll execjs therubyracer

if(NOT BUILD_docs OR NOT DOXYGEN_FOUND)
  return()
endif()

#################################################################################################
# Gather docs from <root>/examples/**/readme.md
function(gather_readmes_as_prebuild_cmd target gathered_dir root)
  set(full_gathered_dir ${root}/${gathered_dir})

  file(GLOB_RECURSE readmes ${root}/examples/readme.md ${root}/examples/README.md)
  foreach(file ${readmes})
    # Only use file if it is to be included in docs.
    file(STRINGS ${file} file_lines REGEX "include_in_docs: true")

    if(file_lines)
      # Since everything is called readme.md, rename it by its dirname.
      file(RELATIVE_PATH file ${root} ${file})
      get_filename_component(folder ${file} PATH)
      set(new_filename ${full_gathered_dir}/${folder}.md)

      # folder value might be like <subfolder>/readme.md. That's why make directory.
      get_filename_component(new_folder ${new_filename} PATH)
      add_custom_command(TARGET ${target} PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${new_folder}
        COMMAND ln -sf ${root}/${file} ${new_filename}
        COMMENT "Creating symlink ${new_filename} -> ${root}/${file}"
        WORKING_DIRECTORY ${root} VERBATIM)
    endif()
  endforeach()
endfunction()

################################################################################################
# Gather docs from examples/*.ipynb and add YAML front-matter.
function(gather_notebooks_as_prebuild_cmd target gathered_dir root)
  set(full_gathered_dir ${root}/${gathered_dir})

  if(NOT PYTHON_EXECUTABLE)
    message(STATUS "Python interpeter is not found. Can't include *.ipynb files in docs. Skipping...")
    return()
  endif()

  file(GLOB_RECURSE notebooks ${root}/examples/*.ipynb)
  foreach(file ${notebooks})
    file(RELATIVE_PATH file ${root} ${file})
    set(new_filename ${full_gathered_dir}/${file})

    get_filename_component(new_folder ${new_filename} PATH)
    add_custom_command(TARGET ${target} PRE_BUILD
      COMMAND ${CMAKE_COMMAND} -E make_directory ${new_folder}
      COMMAND ${PYTHON_EXECUTABLE} scripts/copy_notebook.py ${file} ${new_filename}
      COMMENT "Copying notebook ${file} to ${new_filename}"
      WORKING_DIRECTORY ${root} VERBATIM)
  endforeach()

  set(${outputs_var} ${outputs} PARENT_SCOPE)
endfunction()

################################################################################################
########################## [ Non macro part ] ##################################################

# Gathering is done at each 'make doc'
file(REMOVE_RECURSE ${PROJECT_SOURCE_DIR}/docs/gathered)

# Doxygen config file path
set(DOXYGEN_config_file ${PROJECT_SOURCE_DIR}/.Doxyfile CACHE FILEPATH "Doxygen config file")

# Adding docs target
add_custom_target(docs COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_config_file}
                       WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
                       COMMENT "Launching doxygen..." VERBATIM)

# Gathering examples into docs subfolder
gather_notebooks_as_prebuild_cmd(docs docs/gathered ${PROJECT_SOURCE_DIR})
gather_readmes_as_prebuild_cmd(docs docs/gathered  ${PROJECT_SOURCE_DIR})

# Auto detect output directory
file(STRINGS ${DOXYGEN_config_file} config_line REGEX "OUTPUT_DIRECTORY[ \t]+=[^=].*")
if(config_line)
  string(REGEX MATCH "OUTPUT_DIRECTORY[ \t]+=([^=].*)" __ver_check "${config_line}")
  string(STRIP ${CMAKE_MATCH_1} output_dir)
  message(STATUS "Detected Doxygen OUTPUT_DIRECTORY: ${output_dir}")
else()
  set(output_dir ./doxygen/)
  message(STATUS "Can't find OUTPUT_DIRECTORY in doxygen config file. Try to use default: ${output_dir}")
endif()

if(NOT IS_ABSOLUTE ${output_dir})
  set(output_dir ${PROJECT_SOURCE_DIR}/${output_dir})
  get_filename_component(output_dir ${output_dir} ABSOLUTE)
endif()

# creates symlink in docs subfolder to code documentation built by doxygen
add_custom_command(TARGET docs POST_BUILD VERBATIM
                   COMMAND ln -sfn "${output_dir}/html" doxygen
                   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/docs
                   COMMENT "Creating symlink ${PROJECT_SOURCE_DIR}/docs/doxygen -> ${output_dir}/html")

# for quick launch of jekyll
add_custom_target(jekyll COMMAND jekyll serve -w -s . -d _site --port=4000
                         WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/docs
                         COMMENT "Launching jekyll..." VERBATIM)

=== Makefile ===
PROJECT := caffe

CONFIG_FILE := Makefile.config
# Explicitly check for the config file, otherwise make -k will proceed anyway.
ifeq ($(wildcard $(CONFIG_FILE)),)
$(error $(CONFIG_FILE) not found. See $(CONFIG_FILE).example.)
endif
include $(CONFIG_FILE)

BUILD_DIR_LINK := $(BUILD_DIR)
ifeq ($(RELEASE_BUILD_DIR),)
	RELEASE_BUILD_DIR := .$(BUILD_DIR)_release
endif
ifeq ($(DEBUG_BUILD_DIR),)
	DEBUG_BUILD_DIR := .$(BUILD_DIR)_debug
endif

DEBUG ?= 0
ifeq ($(DEBUG), 1)
	BUILD_DIR := $(DEBUG_BUILD_DIR)
	OTHER_BUILD_DIR := $(RELEASE_BUILD_DIR)
else
	BUILD_DIR := $(RELEASE_BUILD_DIR)
	OTHER_BUILD_DIR := $(DEBUG_BUILD_DIR)
endif

# All of the directories containing code.
SRC_DIRS := $(shell find * -type d -exec bash -c "find {} -maxdepth 1 \
	\( -name '*.cpp' -o -name '*.proto' \) | grep -q ." \; -print)

# The target shared library name
LIBRARY_NAME := $(PROJECT)
LIB_BUILD_DIR := $(BUILD_DIR)/lib
STATIC_NAME := $(LIB_BUILD_DIR)/lib$(LIBRARY_NAME).a
DYNAMIC_VERSION_MAJOR 		:= 1
DYNAMIC_VERSION_MINOR 		:= 0
DYNAMIC_VERSION_REVISION 	:= 0
DYNAMIC_NAME_SHORT := lib$(LIBRARY_NAME).so
#DYNAMIC_SONAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR)
DYNAMIC_VERSIONED_NAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)
DYNAMIC_NAME := $(LIB_BUILD_DIR)/$(DYNAMIC_VERSIONED_NAME_SHORT)
COMMON_FLAGS += -DCAFFE_VERSION=$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)

##############################
# Get all source files
##############################
# CXX_SRCS are the source files excluding the test ones.
CXX_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cpp" -name "*.cpp")
# CU_SRCS are the cuda source files
CU_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cu" -name "*.cu")
# TEST_SRCS are the test source files
TEST_MAIN_SRC := src/$(PROJECT)/test/test_caffe_main.cpp
TEST_SRCS := $(shell find src/$(PROJECT) -name "test_*.cpp")
TEST_SRCS := $(filter-out $(TEST_MAIN_SRC), $(TEST_SRCS))
TEST_CU_SRCS := $(shell find src/$(PROJECT) -name "test_*.cu")
GTEST_SRC := src/gtest/gtest-all.cpp
# TOOL_SRCS are the source files for the tool binaries
TOOL_SRCS := $(shell find tools -name "*.cpp")
# EXAMPLE_SRCS are the source files for the example binaries
EXAMPLE_SRCS := $(shell find examples -name "*.cpp")
# BUILD_INCLUDE_DIR contains any generated header files we want to include.
BUILD_INCLUDE_DIR := $(BUILD_DIR)/src
# PROTO_SRCS are the protocol buffer definitions
PROTO_SRC_DIR := src/$(PROJECT)/proto
PROTO_SRCS := $(wildcard $(PROTO_SRC_DIR)/*.proto)
# PROTO_BUILD_DIR will contain the .cc and obj files generated from
# PROTO_SRCS; PROTO_BUILD_INCLUDE_DIR will contain the .h header files
PROTO_BUILD_DIR := $(BUILD_DIR)/$(PROTO_SRC_DIR)
PROTO_BUILD_INCLUDE_DIR := $(BUILD_INCLUDE_DIR)/$(PROJECT)/proto
# NONGEN_CXX_SRCS includes all source/header files except those generated
# automatically (e.g., by proto).
NONGEN_CXX_SRCS := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/$(PROJECT) \
	matlab/+$(PROJECT)/private \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh")
LINT_SCRIPT := scripts/cpp_lint.py
LINT_OUTPUT_DIR := $(BUILD_DIR)/.lint
LINT_EXT := lint.txt
LINT_OUTPUTS := $(addsuffix .$(LINT_EXT), $(addprefix $(LINT_OUTPUT_DIR)/, $(NONGEN_CXX_SRCS)))
EMPTY_LINT_REPORT := $(BUILD_DIR)/.$(LINT_EXT)
NONEMPTY_LINT_REPORT := $(BUILD_DIR)/$(LINT_EXT)
# PY$(PROJECT)_SRC is the python wrapper for $(PROJECT)
PY$(PROJECT)_SRC := python/$(PROJECT)/_$(PROJECT).cpp
PY$(PROJECT)_SO := python/$(PROJECT)/_$(PROJECT).so
PY$(PROJECT)_HXX := include/$(PROJECT)/layers/python_layer.hpp
# MAT$(PROJECT)_SRC is the mex entrance point of matlab package for $(PROJECT)
MAT$(PROJECT)_SRC := matlab/+$(PROJECT)/private/$(PROJECT)_.cpp
ifneq ($(MATLAB_DIR),)
	MAT_SO_EXT := $(shell $(MATLAB_DIR)/bin/mexext)
endif
MAT$(PROJECT)_SO := matlab/+$(PROJECT)/private/$(PROJECT)_.$(MAT_SO_EXT)

##############################
# Derive generated files
##############################
# The generated files for protocol buffers
PROTO_GEN_HEADER_SRCS := $(addprefix $(PROTO_BUILD_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_HEADER := $(addprefix $(PROTO_BUILD_INCLUDE_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_CC := $(addprefix $(BUILD_DIR)/, ${PROTO_SRCS:.proto=.pb.cc})
PY_PROTO_BUILD_DIR := python/$(PROJECT)/proto
PY_PROTO_INIT := python/$(PROJECT)/proto/__init__.py
PROTO_GEN_PY := $(foreach file,${PROTO_SRCS:.proto=_pb2.py}, \
		$(PY_PROTO_BUILD_DIR)/$(notdir $(file)))
# The objects corresponding to the source files
# These objects will be linked into the final shared library, so we
# exclude the tool, example, and test objects.
CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o})
CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o})
PROTO_OBJS := ${PROTO_GEN_CC:.cc=.o}
OBJS := $(PROTO_OBJS) $(CXX_OBJS) $(CU_OBJS)
# tool, example, and test objects
TOOL_OBJS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o})
TOOL_BUILD_DIR := $(BUILD_DIR)/tools
TEST_CXX_BUILD_DIR := $(BUILD_DIR)/src/$(PROJECT)/test
TEST_CU_BUILD_DIR := $(BUILD_DIR)/cuda/src/$(PROJECT)/test
TEST_CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o})
TEST_CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o})
TEST_OBJS := $(TEST_CXX_OBJS) $(TEST_CU_OBJS)
GTEST_OBJ := $(addprefix $(BUILD_DIR)/, ${GTEST_SRC:.cpp=.o})
EXAMPLE_OBJS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o})
# Output files for automatic dependency generation
DEPS := ${CXX_OBJS:.o=.d} ${CU_OBJS:.o=.d} ${TEST_CXX_OBJS:.o=.d} \
	${TEST_CU_OBJS:.o=.d} $(BUILD_DIR)/${MAT$(PROJECT)_SO:.$(MAT_SO_EXT)=.d}
# tool, example, and test bins
TOOL_BINS := ${TOOL_OBJS:.o=.bin}
EXAMPLE_BINS := ${EXAMPLE_OBJS:.o=.bin}
# symlinks to tool bins without the ".bin" extension
TOOL_BIN_LINKS := ${TOOL_BINS:.bin=}
# Put the test binaries in build/test for convenience.
TEST_BIN_DIR := $(BUILD_DIR)/test
TEST_CU_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CU_OBJS),$(basename $(notdir $(obj))))))
TEST_CXX_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CXX_OBJS),$(basename $(notdir $(obj))))))
TEST_BINS := $(TEST_CXX_BINS) $(TEST_CU_BINS)
# TEST_ALL_BIN is the test binary that links caffe dynamically.
TEST_ALL_BIN := $(TEST_BIN_DIR)/test_all.testbin

##############################
# Derive compiler warning dump locations
##############################
WARNS_EXT := warnings.txt
CXX_WARNS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o.$(WARNS_EXT)})
CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o.$(WARNS_EXT)})
TOOL_WARNS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o.$(WARNS_EXT)})
EXAMPLE_WARNS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_WARNS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o.$(WARNS_EXT)})
ALL_CXX_WARNS := $(CXX_WARNS) $(TOOL_WARNS) $(EXAMPLE_WARNS) $(TEST_WARNS)
ALL_CU_WARNS := $(CU_WARNS) $(TEST_CU_WARNS)
ALL_WARNS := $(ALL_CXX_WARNS) $(ALL_CU_WARNS)

EMPTY_WARN_REPORT := $(BUILD_DIR)/.$(WARNS_EXT)
NONEMPTY_WARN_REPORT := $(BUILD_DIR)/$(WARNS_EXT)

##############################
# Derive include and lib directories
##############################
CUDA_INCLUDE_DIR := $(CUDA_DIR)/include

CUDA_LIB_DIR :=
# add <cuda>/lib64 only if it exists
ifneq ("$(wildcard $(CUDA_DIR)/lib64)","")
	CUDA_LIB_DIR += $(CUDA_DIR)/lib64
endif
CUDA_LIB_DIR += $(CUDA_DIR)/lib

INCLUDE_DIRS += $(BUILD_INCLUDE_DIR) ./src ./include
ifneq ($(CPU_ONLY), 1)
	INCLUDE_DIRS += $(CUDA_INCLUDE_DIR)
	LIBRARY_DIRS += $(CUDA_LIB_DIR)
	LIBRARIES := cudart cublas curand
endif

LIBRARIES += glog gflags protobuf boost_system boost_filesystem m hdf5_hl hdf5

# handle IO dependencies
USE_LEVELDB ?= 1
USE_LMDB ?= 1
USE_OPENCV ?= 1

ifeq ($(USE_LEVELDB), 1)
	LIBRARIES += leveldb snappy
endif
ifeq ($(USE_LMDB), 1)
	LIBRARIES += lmdb
endif
ifeq ($(USE_OPENCV), 1)
	LIBRARIES += opencv_core opencv_highgui opencv_imgproc

	ifeq ($(OPENCV_VERSION), 3)
		LIBRARIES += opencv_imgcodecs
	endif

endif
PYTHON_LIBRARIES ?= boost_python python2.7
WARNINGS := -Wall -Wno-sign-compare

##############################
# Set build directories
##############################

DISTRIBUTE_DIR ?= distribute
DISTRIBUTE_SUBDIRS := $(DISTRIBUTE_DIR)/bin $(DISTRIBUTE_DIR)/lib
DIST_ALIASES := dist
ifneq ($(strip $(DISTRIBUTE_DIR)),distribute)
		DIST_ALIASES += distribute
endif

ALL_BUILD_DIRS := $(sort $(BUILD_DIR) $(addprefix $(BUILD_DIR)/, $(SRC_DIRS)) \
	$(addprefix $(BUILD_DIR)/cuda/, $(SRC_DIRS)) \
	$(LIB_BUILD_DIR) $(TEST_BIN_DIR) $(PY_PROTO_BUILD_DIR) $(LINT_OUTPUT_DIR) \
	$(DISTRIBUTE_SUBDIRS) $(PROTO_BUILD_INCLUDE_DIR))

##############################
# Set directory for Doxygen-generated documentation
##############################
DOXYGEN_CONFIG_FILE ?= ./.Doxyfile
# should be the same as OUTPUT_DIRECTORY in the .Doxyfile
DOXYGEN_OUTPUT_DIR ?= ./doxygen
DOXYGEN_COMMAND ?= doxygen
# All the files that might have Doxygen documentation.
DOXYGEN_SOURCES := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/ \
	matlab/ \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh" -or \
        -name "*.py" -or -name "*.m")
DOXYGEN_SOURCES += $(DOXYGEN_CONFIG_FILE)


##############################
# Configure build
##############################

# Determine platform
UNAME := $(shell uname -s)
ifeq ($(UNAME), Linux)
	LINUX := 1
else ifeq ($(UNAME), Darwin)
	OSX := 1
	OSX_MAJOR_VERSION := $(shell sw_vers -productVersion | cut -f 1 -d .)
	OSX_MINOR_VERSION := $(shell sw_vers -productVersion | cut -f 2 -d .)
endif

# Linux
ifeq ($(LINUX), 1)
	CXX ?= /usr/bin/g++
	GCCVERSION := $(shell $(CXX) -dumpversion | cut -f1,2 -d.)
	# older versions of gcc are too dumb to build boost with -Wuninitalized
	ifeq ($(shell echo | awk '{exit $(GCCVERSION) < 4.6;}'), 1)
		WARNINGS += -Wno-uninitialized
	endif
	# boost::thread is reasonably called boost_thread (compare OS X)
	# We will also explicitly add stdc++ to the link target.
	LIBRARIES += boost_thread stdc++
	VERSIONFLAGS += -Wl,-soname,$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../lib
endif

# OS X:
# clang++ instead of g++
# libstdc++ for NVCC compatibility on OS X >= 10.9 with CUDA < 7.0
ifeq ($(OSX), 1)
	CXX := /usr/bin/clang++
	ifneq ($(CPU_ONLY), 1)
		CUDA_VERSION := $(shell $(CUDA_DIR)/bin/nvcc -V | grep -o 'release [0-9.]*' | tr -d '[a-z ]')
		ifeq ($(shell echo | awk '{exit $(CUDA_VERSION) < 7.0;}'), 1)
			CXXFLAGS += -stdlib=libstdc++
			LINKFLAGS += -stdlib=libstdc++
		endif
		# clang throws this warning for cuda headers
		WARNINGS += -Wno-unneeded-internal-declaration
		# 10.11 strips DYLD_* env vars so link CUDA (rpath is available on 10.5+)
		OSX_10_OR_LATER   := $(shell [ $(OSX_MAJOR_VERSION) -ge 10 ] && echo true)
		OSX_10_5_OR_LATER := $(shell [ $(OSX_MINOR_VERSION) -ge 5 ] && echo true)
		ifeq ($(OSX_10_OR_LATER),true)
			ifeq ($(OSX_10_5_OR_LATER),true)
				LDFLAGS += -Wl,-rpath,$(CUDA_LIB_DIR)
			endif
		endif
	endif
	# gtest needs to use its own tuple to not conflict with clang
	COMMON_FLAGS += -DGTEST_USE_OWN_TR1_TUPLE=1
	# boost::thread is called boost_thread-mt to mark multithreading on OS X
	LIBRARIES += boost_thread-mt
	# we need to explicitly ask for the rpath to be obeyed
	ORIGIN := @loader_path
	VERSIONFLAGS += -Wl,-install_name,@rpath/$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../../build/lib
else
	ORIGIN := \$$ORIGIN
endif

# Custom compiler
ifdef CUSTOM_CXX
	CXX := $(CUSTOM_CXX)
endif

# Static linking
ifneq (,$(findstring clang++,$(CXX)))
	STATIC_LINK_COMMAND := -Wl,-force_load $(STATIC_NAME)
else ifneq (,$(findstring g++,$(CXX)))
	STATIC_LINK_COMMAND := -Wl,--whole-archive $(STATIC_NAME) -Wl,--no-whole-archive
else
  # The following line must not be indented with a tab, since we are not inside a target

=== gtest/CMakeLists.txt ===
add_library(gtest STATIC EXCLUDE_FROM_ALL gtest.h gtest-all.cpp)
caffe_default_properties(gtest)
target_include_directories(gtest PUBLIC ${Caffe_SRC_DIR})
target_compile_definitions(gtest PUBLIC -DGTEST_USE_OWN_TR1_TUPLE)


#add_library(gtest_main gtest_main.cc)
#target_link_libraries(gtest_main gtest)

## caffe-contrib 1.0.0~rc4

=== debian/changelog ===
caffe-contrib (1.0.0~rc4-1) unstable; urgency=medium

  * New upstream release.
  * Rules: update URL for get-orig-source target.
  * Bump debhelper compat to 10.
  * Patch: add cmake-bump-soversion-to-rc4.patch to fix upstream soversion.
  * Rules: now CAFFE_SOVER is `1.0.0-rc4`.
  * Get rid of symbols control file to avoid endless FTBFS bugs caused
    by symbol changes.
  * Don't miss the pytest target on the dh_auto_test phase.
  * Rules: update LD_LIBRARY_PATH for dh_auto_test.
  * Rules: Remove all `__pycache__` directories on clean.
  * Refresh lintian overrides.
  * Remove patch: 0001-Add-Pascal-to-all-cuda-architectures.patch,
    which is included in this release.

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 22 Jan 2017 02:34:16 +0000

caffe-contrib (1.0.0~rc3+20161127-g24d2f67-4) unstable; urgency=medium

  * Add patch: cmake-link-correct-python-lib.patch from src:caffe to fix
    the FTBFS (See #850989).

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 12 Jan 2017 04:45:21 +0000

caffe-contrib (1.0.0~rc3+20161127-g24d2f67-3) unstable; urgency=medium

  * Avoid autopkgtest failure by fixing stderr redirection.
  * Remove deprecated autopkgtest scripts.
  * Cherry-pick upstream commit 8cd5c3df98734f4c43e1b7f43c05401fda0a94ac:
    "Add Pascal to all cuda architectures", to better support Pascal cards.

 -- Zhou Mo <cdluminate@gmail.com>  Fri, 09 Dec 2016 02:17:17 +0000

caffe-contrib (1.0.0~rc3+20161127-g24d2f67-2) unstable; urgency=medium

  * Refresh symbols control file for amd64.
  * Redirect all autopkgtest scripts's stderr output to stdout.
  * Upload to unstable.

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 29 Nov 2016 01:27:45 +0000

caffe-contrib (1.0.0~rc3+20161127-g24d2f67-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Import patch: fix-more-float-comparison-precision-issue2 from cpu version.
  * Refresh symbols control file.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 28 Nov 2016 11:40:07 +0000

caffe-contrib (1.0.0~rc3+20160930-ga7f950b-2) experimental; urgency=medium

  * Change compiler from GCC-5 to Clang-3.8 .
  * Replace GCC-5 with Clang-3.8 in B-D list.
  * Remove NVCC flag "-D_FORCE_INLINES" (CUDA 7.5 workaround).
  * Refresh symbols control file for amd64.
  * Import changes from «src:caffe_1.0.0~rc3+20160930-ga7f950b-3» :
    + autopkgtest files : general update
    + README.Debian : general update
    + control : add python3-protobuf to B-D; force the use of optimized BLAS.
    + rules: fix more permissions
    + patches: patch descriptions

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 28 Nov 2016 02:49:21 +0000

caffe-contrib (1.0.0~rc3+20160930-ga7f950b-1) experimental; urgency=medium

  * Import upstream snapshot (ga7f950b). (Closes: #838789)
  * Suggest OpenBLAS/Atlas library for metapackage caffe-cuda.
  * Add git and libboost-dev to make cmake happy.
  * Update package description.
  * Update txt2man template d/man/caffe.txt and its corresponding manpage.
  * Import several patches from source package "caffe" :
    + cmake-avoid-argument-missing
    + cmake-fix-python-module-installdir
    + fix-more-float-comparison-precision-issue
  * Remove following merged patches:
    - fix-spelling-error
  * Remove cherry-picked changes that are already present in this snapshot.
    - upstream-dont-set-map-size-1TB-in-db-lmdb.patch
    - upstream-print-to-stderr-for-example-LMDB-code.patch
    - upstream-update-MNIST-example-to-use-new-DB-classes.patch
  * Disable -pedantic compiler option to reduce build log size.
  * Add --list-missing option to dh_install.
  * Import updated bash completion script d/script/caffe from src:caffe.
  * Refresh symbols control file.
  * Synchronize packaging with src:caffe (1.0.0~rc3+20160930-ga7f950b-1).

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 02 Oct 2016 15:08:56 +0000

caffe-contrib (1.0.0~rc3-2) experimental; urgency=medium

  * Add NVCC flag "-D_FORCE_INLINES".
  * Cherry-pick upstream fixes for map size issue.
    - dont-set-map-size-1TB-in-db-lmdb
    - print-to-stderr-for-example-LMDB-code
    - update-MNIST-example-to-use-new-DB-classes
  * Synchronize packaging with src:caffe (1.0.0~rc3-4).
    + Import README.Debian from src:caffe.
  * Update symbols control file.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 28 Jul 2016 02:58:40 +0000

caffe-contrib (1.0.0~rc3-1) experimental; urgency=low

  * Initial release. (Closes: #823308)

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 04 Jul 2016 14:37:52 +0000

=== debian/control ===
Source: caffe-contrib
Section: contrib/science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Zhou Mo <cdluminate@gmail.com>
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper (>=10),
               dh-python,
               git,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4),
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-leveldb,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-scipy,
               python3-six,
               python3-yaml,
# The above part is synced with main/caffe
# The following part is CUDA related B-D
               nvidia-cuda-toolkit (>= 7.5.18) [amd64 ppc64el],
               clang-3.8,
Standards-Version: 3.9.8
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/caffe-contrib.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/caffe-contrib.git
X-Python-Version: >= 3.3

Package: caffe-cuda
Section: contrib/metapackages
Architecture: amd64 ppc64el
Depends: caffe-tools-cuda   (= ${binary:Version}),
         python3-caffe-cuda (= ${binary:Version}),
         libcaffe-cuda1     (= ${binary:Version}),
# the default libblas.so.3 comes from pkg:libblas3, with low performance.
         libopenblas-base | libatlas3-base | libblas.so.3 ,
         ${misc:Depends},
Suggests: libcaffe-cuda-dev  (= ${binary:Version}),
          caffe-doc,
Conflicts: caffe-cpu
Description: Fast, open framework for Deep Learning (Meta)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 This metapackage pulls CUDA version of caffe:
  * caffe-tools-cuda
  * libcaffe-cuda*
  * python3-caffe-cuda
 And suggests these packages:
  * libcaffe-cuda-dev
  * caffe-doc
 .
 Note, this CUDA version cannot co-exist with the CPU_ONLY version.

Package: caffe-tools-cuda
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: caffe-tools-cpu
Description: Tools for fast, open framework for Deep Learning (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe executables, configured with CUDA.

Package: libcaffe-cuda1
Section: contrib/libs
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libcaffe-cpu1
Description: library of Caffe, deep leanring framework (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe shared library, configured with CUDA.

Package: libcaffe-cuda-dev
Section: contrib/libdevel
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}), ${misc:Depends}
Conflicts: libcaffe-cpu-dev
Suggests: caffe-doc
Description: development files for Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains the development files of caffe.

Package: python3-caffe-cuda
Section: contrib/python
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
Conflicts: python3-caffe-cpu
Description: Python3 interface of Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains the CUDA version of python3 Caffe interface.

# caffe-doc is built by main/caffe, the CPU version.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Hardening Caffe according to https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CFLAGS_MAINT_APPEND   = -Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
RULES         := debian/rules
ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc4.tar.gz"
CAFFE_SOVER   := 1.0.0-rc4
BUILDDIR      := "caffe_cuda_build"

TEMPLATES     := $(wildcard debian/*.in)
AUTOGEN       := $(patsubst %.in,%,$(TEMPLATES))

## CMake Configuration Template.
## Should sync this with the caffe CPU_ONLY version.
CMAKE_CONFIGURE_TEMPLATE = \
	-DALLOW_LMDB_NOLOCK=OFF \
	-DBLAS="Generic" \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_docs=OFF \
	-DBUILD_matlab=OFF \
	-DBUILD_python=ON \
	-DBUILD_python_layer=ON \
	-Dpython_version="3" \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DUSE_CUDNN=OFF \
	-DUSE_LEVELDB=ON \
	-DUSE_LMDB=ON \
	-DUSE_OPENCV=ON \
	-DCPU_ONLY=$(FILL_THIS_BLANK) \
	-DCMAKE_INSTALL_PREFIX="/usr"
# TODO: use CUDA arches suggested by nvidia people

CONFFLAG_CUDA = \
	$(CMAKE_CONFIGURE_TEMPLATE) \
	-DCPU_ONLY=OFF \
	-DCUDA_ARCH_NAME="All" \
	-DCMAKE_CXX_COMPILER=clang++-3.8 \
	-DCMAKE_C_COMPILER=clang-3.8

%:: %.in
	perl -p \
	-e 's{#CAFFE_CONFIGURE#}{caffe_cuda}g;' \
	-e 's{#CAFFE_SOVER#}{$(CAFFE_SOVER)}g;' \
	-e 's{#DEB_HOST_MULTIARCH#}{$(DEB_HOST_MULTIARCH)}g;' \
	< $< > $@

%:
	dh $@ \
		--parallel \
		--buildsystem=cmake \
		--with python3,bash-completion

override_dh_auto_configure: $(AUTOGEN)
	dh_auto_configure --builddirectory=$(BUILDDIR) \
		-- $(CONFFLAG_CUDA)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(BUILDDIR)
	-$(RM) -rf python/caffe/proto/ doxygen
	-$(RM) python/caffe/_caffe.so
	-find . -type d -name '__pycache__' -exec rm -rf '{}' +

override_dh_auto_build:
	dh_auto_build --builddirectory=$(BUILDDIR) \
		-- caffe pycaffe test.testbin all

# In the test phase, we need to set LD_LIBRARY_PATH properly
# for those test ELFs linked with libcaffe.so.X
override_dh_auto_test: 
	# the i386/amd64 build machine may have no CUDA-capable
	# video card. Hence heading with a dash.
	-dh_auto_test --builddirectory=$(BUILDDIR) \
		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/ 

override_dh_python3:
	dh_python3 --requires=python/requirements.txt
	dh_numpy3

override_dh_install:
	dh_install --list-missing

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR) -- install

override_dh_makeshlibs:
	dh_makeshlibs --package=python3-caffe-cuda -X/usr/lib/python
	dh_makeshlibs --remaining-packages

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/caffe_pb2.py
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py

get-orig-source:
	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc4.orig.tar.gz

## caffe-contrib 1.0.0

=== debian/changelog ===
caffe-contrib (1.0.0-6build1) bionic; urgency=medium

  * No-change rebuild against CUDA 9.1

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 05 Mar 2018 19:04:33 +0000

caffe-contrib (1.0.0-6) unstable; urgency=medium

  * Add a commented patch from ubuntu.
  * Bump debhelper compat to 11.
  * Bump Standards-Version to 4.1.3 (no change).
  * Point Vcs-* fields to Salsa.
  * Don't hardcode python3.5 in the patch.
  * Fix insecure-copyright-format-uri.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Jan 2018 09:55:40 +0000

caffe-contrib (1.0.0-5) unstable; urgency=medium

  * Apply updates from upstream master branch.
    - Remove merged patch cmake-change-static-lib-name.patch.
  * Add patch to deprecate old GPU archs.
    + cmake-deprecate-old-gpu-arch.patch
  * Build with GCC-6 and CUDA9.0 .
  * Add temporary fix for boost1.62 + CUDA9.0 .
    + fix-compat-boost-cuda.patch

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 23 Jan 2018 13:39:15 +0000

caffe-contrib (1.0.0-4) unstable; urgency=medium

  * Change compiler from Clang-3.8 back to GCC-5. (Closes: #871232, #873405)
    Although the GCC-5 removal will trigger a new RC bug, however at
    least this change makes the package buildable.
  * Update my name in control and copyright.
  * Bump Standards-Version to 4.1.1 . No change needed.
  * Use dh_missing --list-missing instead of dh_install --list-missing.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 26 Oct 2017 05:07:43 +0000

caffe-contrib (1.0.0-3) unstable; urgency=medium

  * Upload to unstable.
  * Set multi-arch of the dev package to same.
  * Bump Standards Version to 4.0.0 (needs no change).

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 04 Jul 2017 09:47:52 +0000

caffe-contrib (1.0.0-2) experimental; urgency=medium

  * Rename static library libproto.a -> libcaffeproto.a and add it back
    to the -dev package. (Closes: #862528)

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 15 May 2017 02:12:33 +0000

caffe-contrib (1.0.0-1) experimental; urgency=medium

  * New upstream release. (packaging synchronized with src:caffe)
  * Patchset update:
    - Remove post_rc5_upstream_updates.patch (included in upstream).
    - Remove cmake-using-gnuinstalldirs (merged).
    - Remove fix-more-float-comparison-precision-issue (merged).
  * Rules: update CAFFE_SOLVER and get-orig-source accordingly.
  * Control:
    + Add new dependency: python3-pydotplus .
    + Update description: upstream Lab renamed from BVLC to BAIR.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 01 May 2017 01:32:29 +0000

caffe-contrib (1.0.0~rc5-1) experimental; urgency=medium

  * New upstream RC release.
  * Update CAFFE_SOLVER and get-orig-source target in rules.
  * Update patchset (synchronized from src:caffe package):
    - Remove cmake-avoid-argument-missing, cmake-bump-soversion-to-rc4.patch .
    - Refresh the other patches.
    - Cherry-pick upstream updates to rc5: post_rc5_upstream_updates.patch .

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 09 Apr 2017 14:51:50 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: contrib/science
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Zhou Mo <cdluminate@gmail.com>
+Uploaders: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: bc,
                cmake,
                bash-completion,
-               debhelper (>=10),
+               debhelper (>=11~),
                dh-python,
                git,
 # libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
@@ -45,17 +45,19 @@
 #              python3-opencv, # this is recommended if available but it doesn't block
                python3-pandas,
                python3-pil,
+               python3-pydotplus,
                python3-scipy,
                python3-six,
                python3-yaml,
 # The above part is synced with main/caffe
 # The following part is CUDA related B-D
-               nvidia-cuda-toolkit (>= 7.5.18) [amd64 ppc64el],
-               clang-3.8,
-Standards-Version: 3.9.8
+               nvidia-cuda-toolkit (>= 9.0.176) [amd64 ppc64el],
+               gcc-6,
+               g++-6,
+Standards-Version: 4.1.3
 Homepage: http://caffe.berkeleyvision.org
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/caffe-contrib.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/caffe-contrib.git
+Vcs-Browser: https://salsa.debian.org/science-team/caffe-contrib
+Vcs-Git: https://salsa.debian.org/science-team/caffe-contrib.git
 X-Python-Version: >= 3.3
 
 Package: caffe-cuda
@@ -72,8 +74,8 @@
 Conflicts: caffe-cpu
 Description: Fast, open framework for Deep Learning (Meta)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  This metapackage pulls CUDA version of caffe:
   * caffe-tools-cuda
@@ -94,8 +96,8 @@
 Conflicts: caffe-tools-cpu
 Description: Tools for fast, open framework for Deep Learning (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains caffe executables, configured with CUDA.
 
@@ -107,22 +109,22 @@
 Conflicts: libcaffe-cpu1
 Description: library of Caffe, deep leanring framework (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR)and community contributors.
  .
  It contains caffe shared library, configured with CUDA.
 
 Package: libcaffe-cuda-dev
 Section: contrib/libdevel
 Architecture: amd64 ppc64el
-Multi-Arch: foreign
+Multi-Arch: same
 Depends: libcaffe-cuda1 (= ${binary:Version}), ${misc:Depends}
 Conflicts: libcaffe-cpu-dev
 Suggests: caffe-doc
 Description: development files for Caffe (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains the development files of caffe.
 
@@ -137,8 +139,8 @@
 Conflicts: python3-caffe-cpu
 Description: Python3 interface of Caffe (CUDA)
  Caffe is a deep learning framework made with expression, speed,
- and modularity in mind. It is developed by the Berkeley Vision
- and Learning Center (BVLC) and community contributors.
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
  .
  It contains the CUDA version of python3 Caffe interface.

=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,16 @@
 export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
 export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
 
+# Try this if it fails to build with a new glibc.
+# Thanks to Gianfranco Costamagna <locutusofborg@debian.org>
+#export DEB_CFLAGS_MAINT_APPEND   = -Wall -D_GLIBCXX_USE_C99_MATH=1
+#export DEB_CXXFLAGS_MAINT_APPEND = -Wall -D_GLIBCXX_USE_C99_MATH=1
+
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 RULES         := debian/rules
-ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc4.tar.gz"
-CAFFE_SOVER   := 1.0.0-rc4
+ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/1.0.tar.gz"
+CAFFE_SOVER   := 1.0.0
 BUILDDIR      := "caffe_cuda_build"
 
 TEMPLATES     := $(wildcard debian/*.in)
@@ -39,14 +44,13 @@
 	-DUSE_OPENCV=ON \
 	-DCPU_ONLY=$(FILL_THIS_BLANK) \
 	-DCMAKE_INSTALL_PREFIX="/usr"
-# TODO: use CUDA arches suggested by nvidia people
 
 CONFFLAG_CUDA = \
 	$(CMAKE_CONFIGURE_TEMPLATE) \
 	-DCPU_ONLY=OFF \
 	-DCUDA_ARCH_NAME="All" \
-	-DCMAKE_CXX_COMPILER=clang++-3.8 \
-	-DCMAKE_C_COMPILER=clang-3.8
+	-DCMAKE_CXX_COMPILER=g++-6 \
+	-DCMAKE_C_COMPILER=gcc-6
 
 %:: %.in
 	perl -p \
@@ -77,18 +81,19 @@
 
 # In the test phase, we need to set LD_LIBRARY_PATH properly
 # for those test ELFs linked with libcaffe.so.X
-override_dh_auto_test: 
+override_dh_auto_test:
 	# the i386/amd64 build machine may have no CUDA-capable
 	# video card. Hence heading with a dash.
 	-dh_auto_test --builddirectory=$(BUILDDIR) \
-		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/ 
+		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/
 
 override_dh_python3:
 	dh_python3 --requires=python/requirements.txt
 	dh_numpy3
 
 override_dh_install:
-	dh_install --list-missing
+	dh_install
+	dh_missing --list-missing
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory=$(BUILDDIR) -- install
@@ -103,4 +108,4 @@
 	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py
 
 get-orig-source:
-	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc4.orig.tar.gz
+	wget -c $(ORIG_SOURCE) -O caffe_1.0.0.orig.tar.gz

=== debian/tests/control ===
Tests: simply.run

Tests: test.forward.backward.lenet

Tests: test.python3.import

Tests: test.python3.simple.forward

## caffe-contrib 1.0.0%7erc3%2b20161127

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 STATIC_NAME := $(LIB_BUILD_DIR)/lib$(LIBRARY_NAME).a
 DYNAMIC_VERSION_MAJOR 		:= 1
 DYNAMIC_VERSION_MINOR 		:= 0
-DYNAMIC_VERSION_REVISION 	:= 0
+DYNAMIC_VERSION_REVISION 	:= 0-rc3
 DYNAMIC_NAME_SHORT := lib$(LIBRARY_NAME).so
 #DYNAMIC_SONAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR)
 DYNAMIC_VERSIONED_NAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)
